% Division_prediction_launcher version 1.1
% Created 02/10/2015 from Launcher_ascidians version 1.3
% General launcher for zebrafish, urchins, xenopus and ascidians.
% Note : This program is compatible only with older versions of Matlab (2007-2010 ?)
% For more recent versions, it would need to be adapted.


clear all
close all
pause(2);
disp(' '); disp(' ');
disp('Running division prediction program...');
disp(' ');


%% Plots and replots parameters

Replot=0;		% Loads existing backup file to avoid calculation. 1 to avoid random walk, 2 to avoid random walk and angular potential calculation.
isave=100261;						% number of read file if replot, otherwise does not matter
digits = 4;                     % For read images
% Plot and replot features : 1 to plot them, 0 otherwise
Plotpos=1;		% Nucleus position and orientation plot
Plotagl=0;		% Angular potential calculation and graph
Plottorque=0;   % Angular potential calculation and angular torque plot
Plotresult=0;   % Angular potential calculation and corresponding nucleus position and orientation plot
precision_angles=10;        % Angular precision of the angular potential calculation and plots (in degrees)



%% Biological and scaling parameters

caract_length=79.37;        % Radius of the zygote (in pixels). Note that lengths are normalized in the calculation (Force_calculation_11, line 169).
anglelimit=1/2+1/8+1/4;     % Angular extension of the asters, 1 correspond to 360 degrees (for each aster)
Nucsize=20;                 % Nuclear diameter, ie distance btw centrosomes (in pixels)
Nucexcl=2.85;                  % Nuclear size factor for membrane exclusion, ie Nucsize*Nucexcl/2 is the minimal distance btw nucleus center and membrane. Nucexcl can't be <1.

% Force equation : F = L^Beta1 + pullfactor*L^Beta2 + pullfactor_exp*2^(L/Unit_branch)
% If no cap, set pullfactor and pullfactor_exp to 0
Beta1=3;
Beta2=2;
Unit_branch=6.75; % In um, for a 45 um diameter embryo (as lengths are normalized in the calculation, see Division_prediction_program version 1.1, line 11)
pullfactor=0;
pullfactor_exp=0;

% In article : MTstab is eta, gradyolk is  and erfoffset is epsilon. See Supplemental document 'Yolk gradient parameters'.
% If no yolk, empty gradyolk
MTstab=1;                    % Robustness of MT in yolk. 1 is default.
gradyolk=[50];               % Sharpness of the yolk gradient. Several if several gradients.
direction_grad=[180 90];    % Direction of the yolk gradient. n x 2 matrix. Lines are theta and phi (in degrees) of the gradient axis, columns are the number of gradients.
erfoffset=[48];             % Offset of yolk upper limit towards equator of the cell, after infinite time of sedimentation (in pixels). If 0 then half of the cell is yolk. If < 0 less yolk, if > 0 more yolk. Several if several gradients.
% Warnings : Gradient on the whole 3D image, cropping matters ! So far double directions not tested on non-cubic images.



%% File and program parameters

% Working directory must contain three folders : 'Shapes', 'Plots' and 'Matlab_backups'
rawpath='C:\Users\Analle\Matlab_Codes\Division_prediction';   % Path to working directory
path_images2='cell_2';                         % Folder containing the input images (in 'Shapes' folder). Contains the shape stack and a 'polarity' folder containing the polarity stack
frames=1:160;     % Read frames of the input shape and polarity stacks
cellulechoix=[];  % If stacks contain several cells, number(s) of the studied cell(s). If empty, all cells will be taken
miss_slides=1;    % 1 if the program should consider an empty slide as the limit btw 2 cells, 0 else

theta=45;         % Starting theta
phi=5;           % Starting phi
startingxyz=[];   % Starting x, y and z. If empty, the starting position will be the cell centroid

itmax=10000;             % Maximum number of iterations
paramchoix=500;          % Number of iterations (with x, y, z, theta and phi not changing) necessary to consider the equilibrium is reachad
proba_saut=1;            % Ponderation of keeping the new position even if not favorable. Between 0 and 50, default is 1.
inertie=50;				 % increase of the chance (in %) to go on the same direction if a change was favorable. 100% : never change direction, 0% : random change


%% Calculation

Frames_reading_program_11



