% Division_prediction_program version 1.1
% Created 02/10/15 from Simulation_CellShape_spindle_3D_xenopus version 3.4
% Performs the division simulation and plots its results
% calls Force_calculation_11 for the force calculation (at every step of the gradient descent)



%% not to be changed parameters

seuil_pol=0.01;           % Intensity of polarity threshold above which the cap is seen for the exp term. Between 0 and 1.
Unit_branch_2=Unit_branch/45;
densMT=(pi*2*(1-cos(anglelimit*pi)));     % Number of MTs per solid angle unit (1 rd2) - transparent parameter

if Replot==0 || ~exist([rawpath '\Matlab_backups/random_walk_history_' num2str(isave) '.mat'],'file')
    if Replot>0 && ~exist([rawpath '\Matlab_backups/random_walk_history_' num2str(isave) '.mat'],'file')
        disp('backup file not found, replot mode impossible, calculation starting...');
    end

    %% Preallocations

    CoordsPotentiel=NaN(itmax,5);
    Potentiel=NaN(itmax,5);
    nb_pioches=0;
    Asub=NaN(sizeimages(1),sizeimages(2),Znumberfr);
    Z0=1;
    XcYc = cell(Znumberfr,1);
    echec=0;

    for z=framestart:frameend       % Asub is the shape 3D matrix
        Asub(:,:,Z0)=Label{z,1};                                                                                                                                                          %#ok<USENS> % matrice 3D contenant 1 a l'interieur de la cellule, 0 a l'exterieur
        Z0=Z0+1;
    end

    for Z0=1:Znumberfr
        [xc,yc]=find(Asub(:,:,Z0)==1);
        XcYc{Z0,1}=[xc,yc];                                                                                             % tableau des y et x existants pour chaque z
    end

    Diststart=sqrt(size(Asub,1)^2+ size(Asub,2)^2+size(Asub,3)^2)+10;
    
    
    %% Yolk matrix
    
    disp('    creating yolk matrix...');

    Csub=zeros(size(Label{z,1},1),size(Label{z,1},2),Znumberfr);   % Creation of Csub, the yolk gradient, and Csub2, its complementary...
    Csub2=zeros(size(Label{z,1},1),size(Label{z,1},2),Znumberfr);

    if ~isempty(gradyolk)
        if length(gradyolk)==size(direction_grad,1) && length(gradyolk)==length(erfoffset)

            for nbgrad=1:length(gradyolk)   % For every defined gradient...
                Csubtemp=zeros(size(Label{z,1},1),size(Label{z,1},2),Znumberfr);
                Csubtemp2=zeros(size(Label{z,1},1),size(Label{z,1},2),Znumberfr);
                disp(['        gradient nb ' num2str(nbgrad) ' along direction theta=' num2str(direction_grad(nbgrad,1)) ' and phi=' num2str(direction_grad(nbgrad,2)) '.']);

                unitvect=[cos(direction_grad(nbgrad,2)*pi/180)*sin(direction_grad(nbgrad,1)*pi/180), sin(direction_grad(nbgrad,2)*pi/180)*sin(direction_grad(nbgrad,1)*pi/180), cos(direction_grad(nbgrad,1)*pi/180)]; % vector unity in the direction of the gradient

                for xgrad=1:size(Asub,1)        % Allocate to each pixel a yolk value
                    for ygrad=1:size(Asub,2)
                        for zgrad=1:size(Asub,3)

                            distgrad=(xgrad-round(size(Asub,1)/2)+1)*unitvect(1)+(ygrad-round(size(Asub,2)/2)+1)*unitvect(2)+(zgrad-round(size(Asub,3)/2)+1)*unitvect(3); % distance of the projection of the point on gradient axis to center of image
                            valuegrad=1/2*(1-erf((distgrad-erfoffset(nbgrad))/((size(Asub,1)+size(Asub,2)+size(Asub,3)+4)/3)*gradyolk(nbgrad)/2));
                            valuegrad2=1/2*(1-erf(-(distgrad-erfoffset(nbgrad))/((size(Asub,1)+size(Asub,2)+size(Asub,3)+4)/3)*gradyolk(nbgrad)/2));
                            Csubtemp(xgrad,ygrad,zgrad)=Asub(xgrad,ygrad,zgrad)*valuegrad;
                            Csubtemp2(xgrad,ygrad,zgrad)=Asub(xgrad,ygrad,zgrad)*valuegrad2;

                        end
                    end
                end

                if nbgrad==1
                    Csub=Csubtemp;
                    Csub2=Csubtemp2;
                else            % Yolk gradients superposition
                    Csub=max(Csubtemp,Csub);
                    Csub2=min(Csubtemp2,Csub2);
                end
            end
        else disp('How many yolk gradients ? gradyolk, direction_grad and erfoffset should have the same number of elements.');
            disp('Calculation aborted')
            echec=4;
        end
    else Csub2=Asub;
    end


    %% Initialisation of the gradient descent

    pottempb=[1 1 1 1 1];         % initialisation parameters
    maxpot=0;
    minpot=0;
    init=2;
    pentetorquemax=1;
    penteforcemax=1;
    choix=0;
    XYZ=[];
    it=0;
    ittot=0;
    delancee=1;
    
    if length(startingxyz)==3    % Starting position of the nucleus
        x=startingxyz(1);
        y=startingxyz(2);
        z=startingxyz(3);
    else
        Centercell=round([Stat(1,round(mean(find(emptyimagestemp(:,2)==1))-framestart+1)).Centroid (mean(find(emptyimagestemp(:,2)==1)))]);
        z=(Centercell(3)-framestart+1);       % initial position, centered if possible (if the center of mass is inside the cell)
        centre=regionprops(Asub(:,:,z),'Centroid');
        x=Centercell(2);
        y=Centercell(1);
    end
    
    if theta==0
        theta=180;
    end
    if phi==0
        phi=180;
        theta=180-theta;
    end

    
    %% Check if the nucleus starting position is well inside the cell
    
    if Asub(x,y,z)==0
        x=XcYc{z,1}(ceil(size(XcYc{z,1},1)/5),1);
        y=XcYc{z,1}(ceil(size(XcYc{z,1},1)/2),2);
    end

    nucleus_inside=NaN(101,101,3);              % the program is aborted if the nucleus doesn't start in the cell
    [Xsphere,Ysphere,Zsphere] = sphere(100);
    nucleus_inside(:,:,1)=round(Xsphere*(Nucsize*Nucexcl/2+1)+x);
    nucleus_inside(:,:,2)=round(Ysphere*(Nucsize*Nucexcl/2+1)+y);
    nucleus_inside(:,:,3)=round(Zsphere*(Nucsize*Nucexcl/2+1)+z);
    for inucl=1:size(nucleus_inside,1)
        for jnucl=1:size(nucleus_inside,2)
            if nucleus_inside(inucl,jnucl,1)>0 && nucleus_inside(inucl,jnucl,1)<size(Asub,1) && nucleus_inside(inucl,jnucl,2)>0 && nucleus_inside(inucl,jnucl,2)<size(Asub,2) && nucleus_inside(inucl,jnucl,3)>0 && nucleus_inside(inucl,jnucl,3)<size(Asub,3)
                if Asub(nucleus_inside(inucl,jnucl,1),nucleus_inside(inucl,jnucl,2),nucleus_inside(inucl,jnucl,3))==0
                    echec=4;
                end
            else
                echec=4;
            end
        end
    end
    if echec==4
        disp('Nucleus out of the cell ! Calculation aborted');
    end

    
    %% Check plot
    
 disp('    plotting check plot...');

    h=figure;
    p1 = patch(isosurface(Asub,0.5), 'FaceColor','blue','EdgeColor','none','EdgeAlpha',0.5,'FaceAlpha',0.1); % isosurface of 0.5 value, that is, around the cell
    xlabel('Y','FontSize',14);
    ylabel('X','FontSize',14);
    zlabel('Z','FontSize',14);
    camlight; lighting phong
    axis equal
    camorbit(-35,-75);
    hold on
    daspect([1 1 1]);
    axis tight

       hold on
    p2 = patch(isosurface(Bsub,0.5), 'FaceColor','black','EdgeColor','none','EdgeAlpha',0.5,'FaceAlpha',0.5); % isosurface of 0.5 value, that is, around the cell
    p8 = patch(isosurface(Csub,0.1), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.025); % cap image
    p3 = patch(isosurface(Csub,0.3), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.025);
    p4 = patch(isosurface(Csub,0.5), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.05);
    p5 = patch(isosurface(Csub,0.7), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.05);
    p6 = patch(isosurface(Csub,0.9), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.1);
    camlight; lighting phong
    daspect([1 1 1]);
    plot3(y,x,z,'.k','MarkerSize',12);

    pause(15);
    if echec==4
    else
        close all
    end
    pause(2);

    
    %% Gradient descent calculation...
    
    if ~(echec==4)             % Calculation only if no problem encountered so far

        disp('    calculations over nucleus positions and spindle orentations, random walk...');

        tic;
        while ittot<=itmax          % Gradient descent stopped when specified maximum number of iterations itmax is reached
            echec=0;
            if ittot>paramchoix        % Or when the position has been the same for paramchoix iterations
               if abs(XYZ(length(choix)-paramchoix+1,1)-XYZ(length(choix),1))<=1 && abs(XYZ(length(choix)-paramchoix+1,2)-XYZ(length(choix),2))<=1 && abs(XYZ(length(choix)-paramchoix+1,3)-XYZ(length(choix),3))<=1  && choix(length(choix),1)==0 && sum(pottempb)==sum(minpot)
                    echec=2;
                    ittot=ittot+1;
                end
            end
            if echec==0
                xsave=x;        % Keeping in memory the previous coordinates
                ysave=y;
                zsave=z;
                thetasave=theta;
                phisave=phi;
                
                if choix(length(choix),1)==1		% if a movement was favorable, then greater chance to go on the same direction
                    delancee=ceil(100.*rand(1,1));
                    if delancee<=inertie
                        delancee=2;
                    else delancee=1;
                    end
                else delancee=1;
                end
                if delancee==1
                    de=ceil(10.*rand(1,1)); 				% random x, y, z, theta or phi to change
                end
                if de==1 && theta<180 && pottempb(2)<0
                    thetasave=theta;
                    theta=theta+1; disp(' '); disp(['theta increased to ' num2str(theta)]);
                elseif de==1 && theta==180 && pottempb(2)<0
                    thetasave=theta;
                    theta=1; disp(' ');  disp(['theta increased to ' num2str(theta)]);
                elseif de==2 && theta>1 && pottempb(2)>0
                    thetasave=theta;
                    theta=theta-1; disp(' '); disp(['theta decreased to ' num2str(theta)]);
                elseif de==2 && theta==1 && pottempb(2)>0
                    thetasave=theta;
                    theta=180; disp(' '); disp(['theta decreased to ' num2str(theta)]);
                elseif de==3 && phi<180 && pottempb(1)>0
                    phisave=phi;
                    phi=phi+1; disp(' '); disp(['phi increased to ' num2str(phi)]);
                elseif de==3 && phi==180 && pottempb(1)>0
                    phisave=phi; thetasave=theta; theta=180-theta;
                    phi=1; disp(' '); disp(['phi increased to ' num2str(phi)]);
                elseif de==4 && phi>1 && pottempb(1)<0
                    phisave=phi;
                    phi=phi-1; disp(' '); disp(['phi decreased to ' num2str(phi)]);
                elseif de==4 && phi==1 && pottempb(1)<0
                    phisave=phi; thetasave=theta; theta=180-theta;
                    phi=180; disp(' '); disp(['phi decreased to ' num2str(phi)]);
                elseif de==5 && ismember([x+1,y],XcYc{z,1} ,'rows') && pottempb(3)>0
                    xsave=x;
                    x=x+1; disp(' '); disp(['x increased to ' num2str(x)]);
                elseif de==6 && ismember([x-1,y],XcYc{z,1} ,'rows') && pottempb(3)<0
                    xsave=x;
                    x=x-1; disp(' '); disp(['x decreased to ' num2str(x)]);
                elseif de==7 && ismember([x,y+1],XcYc{z,1} ,'rows') && pottempb(4)>0
                    ysave=y;
                    y=y+1; disp(' '); disp(['y increased to ' num2str(y)]);
                elseif de==8 && ismember([x,y-1],XcYc{z,1} ,'rows') && pottempb(4)<0
                    ysave=y;
                    y=y-1; disp(' '); disp(['y decreased to ' num2str(y)]);
                elseif de==9 && z<Znumberfr && pottempb(5)>0
                    if ismember([x,y],XcYc{z+1,1} ,'rows')
                        zsave=z;
                        z=z+1; disp(' '); disp(['z increased to ' num2str(z)]);
                    end
                elseif de==10 && z>1 && pottempb(5)<0
                    if ismember([x,y],XcYc{z-1,1} ,'rows')
                        zsave=z;
                        z=z-1; disp(' '); disp(['z decreased to ' num2str(z)]);
                    end
                else echec=1;
                end
               
                if x==xsave && y==ysave && z==zsave
                else
                    nucleus_inside=NaN(101,101,3);              % the new position is refused if the nucleus doesn't fit in the cell
                    [Xsphere,Ysphere,Zsphere] = sphere(100);
                    nucleus_inside(:,:,1)=round(Xsphere*(Nucsize*Nucexcl/2+1)+x);
                    nucleus_inside(:,:,2)=round(Ysphere*(Nucsize*Nucexcl/2+1)+y);
                    nucleus_inside(:,:,3)=round(Zsphere*(Nucsize*Nucexcl/2+1)+z);
                    for inucl=1:size(nucleus_inside,1)
                        for jnucl=1:size(nucleus_inside,2)
                            if nucleus_inside(inucl,jnucl,1)>0 && nucleus_inside(inucl,jnucl,1)<size(Asub,1) && nucleus_inside(inucl,jnucl,2)>0 && nucleus_inside(inucl,jnucl,2)<size(Asub,2) && nucleus_inside(inucl,jnucl,3)>0 && nucleus_inside(inucl,jnucl,3)<size(Asub,3)
                                if Asub(nucleus_inside(inucl,jnucl,1),nucleus_inside(inucl,jnucl,2),nucleus_inside(inucl,jnucl,3))==0
                                    echec=3;
                                end
                            else
                                echec=3;
                            end
                        end
                    end
                    if echec==3
                        disp('Nucleus out of the cell ! New position abandonned');
                        x=xsave; y=ysave; z=zsave;
                    end
                end

                if echec==0	% if the new position is possible (nucleus inside the cell)

                    Force_calculation_11        % calculation of forces and torques for the given position and angles

                    ittot=ittot+1;
                    de_saut=100.*rand(1,1);

                    conda= init>=1;   % true if initialisation
                    condb= init==0 && de_saut<proba_saut; %#ok<BDSCI> % true if jumping
                    conddtheta=((de==1 || de==2) && (sign(pottempb(2))==sign(pottempa(2)) || (sign(pottempb(2))~=sign(pottempa(2)) && abs(pottempb(2))>abs(pottempa(2))))); % true if new x ok
                    conddphi=((de==3 || de==4) && (sign(pottempb(1))==sign(pottempa(1)) || (sign(pottempb(1))~=sign(pottempa(1)) && abs(pottempb(1))>abs(pottempa(1))))); % true if new y ok
                    condex=((de==5 || de==6) && (sign(pottempb(3))==sign(pottempa(3)) || (sign(pottempb(3))~=sign(pottempa(3)) && abs(pottempb(3))>abs(pottempa(3))))); % true if new x ok
                    condey=((de==7 || de==8) && (sign(pottempb(4))==sign(pottempa(4)) || (sign(pottempb(4))~=sign(pottempa(4)) && abs(pottempb(4))>abs(pottempa(4))))); % true if new y ok
                    condez=((de==9 || de==10) && (sign(pottempb(5))==sign(pottempa(5)) || (sign(pottempb(5))~=sign(pottempa(5)) && abs(pottempb(5))>abs(pottempa(5))))); % true if new z ok

                    if conda || condb || conddphi || conddtheta || condex || condey || condez;  % conditions to keep the new configuration : initialisation, more favorable configuration, or jumping
                        if condb && ~(conddphi || conddtheta || condex || condey || condez); %      % jumping : proba of keeping the new one anyways, to avoid local pixel/noise related minima
                            choix(length(choix)+1,1)=2; %#ok<AGROW>
                            disp('JUMP !');
                        else
                            if sum(abs(minpot))>sum(abs(pottempa))
                                minpot=pottempa;
                            end
                            choix(length(choix)+1,1)=1; %#ok<AGROW>
                        end
                        
                        newmin=[x,y,z,theta,phi];       % taking the new configuration
                        pottempb=pottempa;
                        
                        if init==2      % Steps for the initialisation of the gradient descent loop
                            init=1;
                            choix=choix(2,1);
                            maxpot=pottempa;
                            minpot=pottempa;
                        elseif init==1
                            init=0;
                            if pottempa>maxpot
                                maxpot=pottempa;
                            else
                                minpot=pottempa;
                            end
                        end
                        
                    else                % not taking the new configuration, coming back to previous
                        disp('actually not');
                        choix(length(choix)+1,1)=0; %#ok<AGROW>
                        x=xsave;
                        y=ysave;
                        z=zsave;
                        theta=thetasave;
                        phi=phisave;
                    end
                    XYZ(size(XYZ,1)+1,1)=x; %#ok<AGROW>        % record of chosen path
                    XYZ(size(XYZ,1),2)=y; %#ok<AGROW>
                    XYZ(size(XYZ,1),3)=z; %#ok<AGROW>

                end
            end
        end
        
        if ittot>=itmax && echec<=1   % If fail to find the minimum...
            disp(['minimum not found, random walk stopped after ' num2str(itmax) ' iterations']);
        end

        
 %% Saving the history and result of the gradient descent
        
        while exist([rawpath '/Matlab_backups/random_walk_history_' num2str(isave) '.mat'],'file') || exist([rawpath '/Matlab_backups/graphs_data_' num2str(isave) '.mat'],'file') || exist([rawpath '/Plots/position_' num2str(isave) '.png'],'file') || exist([rawpath '/Plots/potentiel_' num2str(isave) '.png'],'file')
            isave=isave+1;
        end
        save([rawpath '/Matlab_backups/random_walk_history_' num2str(isave) '.mat'],'gradyolk','MTstab','direction_grad','erfoffset','cellule','x','y','z','theta','phi','XYZ','choix','CoordsPotentiel','Potentiel','minpot','maxpot','mult_int','Asub','Bsub','Csub','Csub2','it','Diststart','Label','framestart','Znumberfr','pullfactor','pullfactor_exp','seuil_pol','Nucsize','Nucexcl','anglelimit','Beta1','Beta2','caract_length','path_images2','Unit_branch');
        disp(['isave=' num2str(isave)]);

        toc;
    end

    
%% If replot, loading backup gradient descent file
    
else
    clear gradyolk
    disp(['loading ' rawpath '/Matlab_backups/random_walk_history_' num2str(isave) '.mat']);
    load([rawpath '/Matlab_backups/random_walk_history_' num2str(isave) '.mat']);
    Unit_branch_2=Unit_branch/45;
end


%% Plots...

if exist([rawpath '/Matlab_backups/random_walk_history_' num2str(isave) '.mat'],'file')

    % Position plot
    if Plotpos==1
        
        phi=phi*pi/180;
        theta=theta*pi/180;

        k=figure;
        p1 = patch(isosurface(Asub,0.5), 'FaceColor','blue','EdgeColor','none','EdgeAlpha',0.5,'FaceAlpha',0.15); % isosurface of 0.5 value, that is, around the cell
        if pullfactor>0 || pullfactor_exp>0
             p11 = patch(isosurface(Bsub,0.5), 'FaceColor','black','EdgeColor','none','EdgeAlpha',0.5,'FaceAlpha',0.25); % isosurface of 0.5 value, that is, around the cell
        end
        if ~isempty(gradyolk)
            p2 = patch(isosurface(Csub,0.1), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.025); % cap image
            p3 = patch(isosurface(Csub,0.2), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.025);
            p4 = patch(isosurface(Csub,0.3), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.05);
            p5 = patch(isosurface(Csub,0.4), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.05);
            p6 = patch(isosurface(Csub,0.5), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.1);
            p7 = patch(isosurface(Csub,0.6), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.1);
            p8 = patch(isosurface(Csub,0.7), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.025); % cap image
            p9 = patch(isosurface(Csub,0.8), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.025);
            p10 = patch(isosurface(Csub,0.9), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.05);
        end

        xlabel('Y','FontSize',14);
        ylabel('X','FontSize',14);
        zlabel('Z','FontSize',14);
        camlight; lighting phong
        axis equal
        camorbit(-35,-75);
        hold on
        plot3(y,x,z,'.k','MarkerSize',30);
        plot3([y+Nucsize*caract_length/15/4*sin(phi)*sin(theta),y-Nucsize*caract_length/15/4*sin(phi)*sin(theta)],[x+Nucsize*caract_length/15/4*cos(phi)*sin(theta),x-Nucsize*caract_length/15/4*cos(phi)*sin(theta)],[z+Nucsize*caract_length/15/4*cos(theta),z-Nucsize*caract_length/15/4*cos(theta)],'-k','LineWidth',3);
        daspect([1 1 1]);
        axis tight
        title(['3D position, ' path_images2 ', cell nb ' num2str(cellule)],'FontSize',14);

        print(k,'-dpng',[rawpath '/Plots/positionpol_' num2str(isave) '.png']);

        if Replot==0
            close all
            pause(2);
        end
    end
    

    %% Potential calculation...
    
    if Plotagl==1 || Plottorque==1 || Plotresult==1

        disp('plotting theta and phi potential...');
        if Replot<2 || ~exist([rawpath '/Matlab_backups/graphs_data_agl_' num2str(isave) '_precision_' num2str(precision_angles) '.mat'],'file')

            if Replot==2 && ~exist([rawpath '/Matlab_backups/graphs_data_agl_' num2str(isave) '_precision_' num2str(precision_angles) '.mat'],'file')
                disp('    backup file not found, replot mode impossible, starting potential calculation...');
            end

            tic;

            % preallocations
            proba_theta_phi=NaN(ceil(181/precision_angles));
            probanorm_theta_phi=NaN(ceil(181/precision_angles));
            Result_pottempa=NaN(ceil(181/precision_angles));
            Result_pottempa1=NaN(ceil(181/precision_angles));
            Result_pottempa2=NaN(ceil(181/precision_angles));
            Potentiel_x=NaN(ceil(181/precision_angles));
            Potentiel_y=NaN(ceil(181/precision_angles));
            Potentiel_x1d=NaN(ceil(181/precision_angles));
            Potentiel_y1d=NaN(ceil(181/precision_angles));
            Potentiel_x2d=NaN(ceil(181/precision_angles));
            Potentiel_y2d=NaN(ceil(181/precision_angles));
            Potentiel_x1r=NaN(ceil(181/precision_angles));
            Potentiel_y1r=NaN(ceil(181/precision_angles));
            Potentiel_x2r=NaN(ceil(181/precision_angles));
            Potentiel_y2r=NaN(ceil(181/precision_angles));
            Potentiel_d=NaN(ceil(181/precision_angles));
            Potentiel_r=NaN(ceil(181/precision_angles));
            
            % Calculation of the force and torque for every theta and phi at the equilibrium position
            for thetaint=0:precision_angles:180
                disp(['    ' num2str(thetaint)]);
                for phiint=0:precision_angles:180
                    if thetaint==0
                        theta=180; %#ok<NASGU>
                    else theta=thetaint; %#ok<NASGU>
                    end
                    if phiint==0
                        phi=180; theta=180-theta;%#ok<NASGU>
                    else phi=phiint; %#ok<NASGU>
                    end

                    Force_calculation_11

                    % Potential calculation
                    if thetaint==0
                        Result_pottempa1(ceil((thetaint+1)/precision_angles),ceil((phiint+1)/precision_angles))=sum((pottempa(1)));
                    else
                        Result_pottempa1(ceil((thetaint+1)/precision_angles),ceil((phiint+1)/precision_angles))=-sum((pottempa(1)));
                    end
                    if phiint==0
                        Result_pottempa2(ceil((thetaint+1)/precision_angles),ceil((phiint+1)/precision_angles))=-sum((pottempa(2)));
                    else
                        Result_pottempa2(ceil((thetaint+1)/precision_angles),ceil((phiint+1)/precision_angles))=sum((pottempa(2)));
                    end
                    Result_pottempa(ceil((thetaint+1)/precision_angles),ceil((phiint+1)/precision_angles))=sum(abs(pottempa(1:2)));
                end
            end

            Result_pottempa_torque=(Result_pottempa1.^2+Result_pottempa2.^2).^(1/2);

            for thetaint=0:precision_angles:180
                for phiint=0:precision_angles:180
                    Potentiel_x1d(ceil((thetaint+1)/precision_angles),ceil((phiint+1)/precision_angles))=sin(thetaint*pi/180)*sum(Result_pottempa1(ceil((thetaint+1)/precision_angles),1:ceil((phiint+1)/precision_angles)))*precision_angles;
                    Potentiel_y2d(ceil((thetaint+1)/precision_angles),ceil((phiint+1)/precision_angles))=sum(Result_pottempa2(1:ceil((thetaint+1)/precision_angles),ceil((phiint+1)/precision_angles)))*precision_angles;
                    Potentiel_x1r(ceil((thetaint+1)/precision_angles),ceil((phiint+1)/precision_angles))=sin(thetaint*pi/180)*sum(Result_pottempa1(ceil((thetaint+1)/precision_angles),ceil((phiint+1)/precision_angles):ceil(181/precision_angles)))*precision_angles;
                    Potentiel_y2r(ceil((thetaint+1)/precision_angles),ceil((phiint+1)/precision_angles))=sum(Result_pottempa2(ceil((thetaint+1)/precision_angles):ceil(181/precision_angles),ceil((phiint+1)/precision_angles)))*precision_angles;
                end
            end

            Potentiel_x1=(Potentiel_x1d-Potentiel_x1r)/2;
            Potentiel_y2=(Potentiel_y2d-Potentiel_y2r)/2;

            for thetaint=0:precision_angles:180         % Limit conditions
                Potentiel_x1(ceil((thetaint+1)/precision_angles),:)=Potentiel_x1(ceil((thetaint+1)/precision_angles),:)-(ceil((thetaint+1)/precision_angles)-1).*(Potentiel_x1(ceil((181)/precision_angles),:)-Potentiel_x1(1,:))./(ceil(181/precision_angles)-1);
                Potentiel_y2(ceil((thetaint+1)/precision_angles),:)=Potentiel_y2(ceil((thetaint+1)/precision_angles),:)-(ceil((thetaint+1)/precision_angles)-1).*(Potentiel_y2(ceil((181)/precision_angles),:)-Potentiel_y2(1,:))./(ceil(181/precision_angles)-1);
            end
            for phiint=0:precision_angles:180
                Potentiel_x1(:,ceil((phiint+1)/precision_angles))=Potentiel_x1(:,ceil((phiint+1)/precision_angles))-(ceil((phiint+1)/precision_angles)-1).*(Potentiel_x1(:,ceil((181)/precision_angles))-Potentiel_x1(:,1))./(ceil(181/precision_angles)-1);
                Potentiel_y2(:,ceil((phiint+1)/precision_angles))=Potentiel_y2(:,ceil((phiint+1)/precision_angles))-(ceil((phiint+1)/precision_angles)-1).*(Potentiel_y2(:,ceil((181)/precision_angles))-Potentiel_y2(:,1))./(ceil(181/precision_angles)-1);
            end

            potentiel_xy=Potentiel_x1+Potentiel_y2;
            
            [promin,thetamin]=min(potentiel_xy); % Find the theta and phi corresponding to the potential minimum
            [promin,phimin]=min(promin);
            thetamin=thetamin(phimin);
            theta=(thetamin-1)*precision_angles;
            phi=(phimin-1)*precision_angles;

            % Saving the results of angular potential calculation
            save([rawpath '/Matlab_backups/graphs_data_agl_' num2str(isave) '_precision_' num2str(precision_angles) '.mat'],'x','y','z','Result_pottempa1','Result_pottempa2','Result_pottempa','Potentiel_x1','Potentiel_y2','potentiel_xy','Result_pottempa_torque','cellule','phi','theta');

            toc;

        else    % loading backup

            disp(['    loading ' rawpath '/Matlab_backups/graphs_data_agl_' num2str(isave) '_precision_' num2str(precision_angles) '.mat']);
            load([rawpath '/Matlab_backups/graphs_data_agl_' num2str(isave) '_precision_' num2str(precision_angles) '.mat']);

        end
        
        
        %% Subsequent plots
        
        % Angular potential plot
        if Plotagl==1

            h=figure;       % plot
            [phiplot thetaplot]=meshgrid(0:precision_angles:180);
            surf(thetaplot,phiplot,potentiel_xy,'Facealpha',.6);
            axis tight;
            xlabel('theta','FontSize',10)
            ylabel('phi','FontSize',10)
            title('potential','FontSize',14);

            print(h,'-dpng',[rawpath '/Plots/potentiel_' num2str(isave) '_precision_' num2str(precision_angles) '.png']);

            if Replot<2
                close all
                pause(2);
            end

        end

        % Angular torque plot
        if Plottorque==1

             g=figure;       % plot
            [phiplot thetaplot]=meshgrid(0:precision_angles:180);
            surf(thetaplot,phiplot,Result_pottempa_torque,'Facealpha',.6);
            axis tight;
            xlabel('theta','FontSize',10)
            ylabel('phi','FontSize',10)
            title('torque','FontSize',14);
            
            print(g,'-dpng',[rawpath '/Plots/torque_' num2str(isave) '_precision_' num2str(precision_angles) '.png']);

            if Replot<2
                close all
                pause(2);
            end

        end

        % Potential-determined position plot
        if Plotresult==1

            phi=phi*pi/180;
            theta=theta*pi/180;

            d=figure;
            p1 = patch(isosurface(Asub,0.5), 'FaceColor','blue','EdgeColor','none','EdgeAlpha',0.5,'FaceAlpha',0.15); % isosurface of 0.5 value, that is, around the cell
            if pullfactor>0 || pullfactor_exp>0
                p11 = patch(isosurface(Bsub,0.5), 'FaceColor','black','EdgeColor','none','EdgeAlpha',0.5,'FaceAlpha',0.5); % isosurface of 0.5 value, that is, around the cell
            end
            if ~isempty(gradyolk)
                p2 = patch(isosurface(Csub,0.1), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.025); % cap image
                p3 = patch(isosurface(Csub,0.2), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.025);
                p4 = patch(isosurface(Csub,0.3), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.05);
                p5 = patch(isosurface(Csub,0.4), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.05);
                p6 = patch(isosurface(Csub,0.5), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.1);
                p7 = patch(isosurface(Csub,0.6), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.1);
                p8 = patch(isosurface(Csub,0.7), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.025);
                p9 = patch(isosurface(Csub,0.8), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.025);
                p10 = patch(isosurface(Csub,0.9), 'FaceColor','black','EdgeColor','none','EdgeAlpha',1,'FaceAlpha',0.05);
            end
            
            xlabel('Y','FontSize',14);
            ylabel('X','FontSize',14);
            zlabel('Z','FontSize',14);
            camlight; lighting phong
            axis equal
            camorbit(-35,-75);
            hold on
            plot3(y,x,z,'.k','MarkerSize',30);
            plot3([y+Nucsize*caract_length/15/4*sin(phi)*sin(theta),y-Nucsize*caract_length/15/4*sin(phi)*sin(theta)],[x+Nucsize*caract_length/15/4*cos(phi)*sin(theta),x-Nucsize*caract_length/15/4*cos(phi)*sin(theta)],[z+Nucsize*caract_length/15/4*cos(theta),z-Nucsize*caract_length/15/4*cos(theta)],'-k','LineWidth',3);
            daspect([1 1 1]);
            axis tight
            title(['3D position, ' path_images2 ', cell nb ' num2str(cellule)],'FontSize',14);

            print(d,'-dpng',[rawpath '/Plots/position_from_pot_' num2str(isave) '_precision_' num2str(precision_angles) '.png']);

            phi=phi/pi*180;
            theta=theta/pi*180;

            if Replot<2
                close all
                pause(2);
            end
        end
                        
    end
else
    disp('No figures can be plotted because the random walk results are not found');
end


