% Frames_reading_program version 1.1
% Created 02/10/2015 from Launcher_Simulation_CellShape_spindle_3D_ascidians version 3.3.2
% Called by Division_prediction_launcher version 1.1.
% Extraction of several cell shapes from embryo z-stacks.
% Then calls Division_prediction_program version 1.1 for the division simulation.



if Replot==0
    
    %% Preallocations %%
    
    Imagespol = cell(length(frames),1);
    Imagesyolk = cell(length(frames),1);
    Imagesshape = cell(length(frames),1);
    Im = cell(length(frames),1);
    BW = cell(length(frames),1);
    BWfinal = cell(length(frames),1);
    Dim = cell(length(frames),1);
    RevBWfinal = cell(length(frames),1);
    Label = cell(length(frames),1);
    Labeltemp = cell(length(frames),1);
    Labelraw = cell(length(frames),1);
    emptyimages=ones(length(frames),3);
    emptyimagestemp=ones(length(frames),3);


    %% Reading the two input 3D stacks

    disp(['    reading input images from folder ' path_images2 '...']);
    
    digits_format =['%0' num2str(digits) 'd'];

    for z=frames                        % reading the 3D polarity matrix from 255 colors grayscale image stack
        filename=['polarity' num2str(z,digits_format)];
        inputimage=[rawpath '\Shapes\' path_images2 '\polarity/' filename '.tif'];
        if exist(inputimage,'file');
            Imagespol{z,1}= double(uint8(imread(inputimage)))/255;
            Imagespol{z,1}(Imagespol{z,1}==0 | Imagespol{z,1}==1)=~Imagespol{z,1}(Imagespol{z,1}==0 | Imagespol{z,1}==1);
            Imagespol{z,1}(Imagespol{z,1}>0 & Imagespol{z,1}<1)=1-Imagespol{z,1}(Imagespol{z,1}>0 & Imagespol{z,1}<1);
        elseif pullfactor>0 || pullfactor_exp>0
            disp(['        ' inputimage ' was not found and was skipped']);
            emptyimages(z,1)=0;
        else
            emptyimages(z,1)=0;
        end
    end

    for z=frames                        % reading the 3D shape matrix from (255 colors) binary image stack
        filename=['shape' num2str(z,digits_format)];
        inputimage=[rawpath '\Shapes\' path_images2 '/' filename '.tif'];
        if exist(inputimage,'file');
            Imagesshape{z,1}= ~imread(inputimage);
            % Label the black part(s)
            Labelraw{z,1}=bwlabel(Imagesshape{z,1});         % first matlab label
            Labeltemp{z,1}=NaN(size(Imagesshape{z,1}));      % new label, following cells
        else
            disp(['        ' inputimage ' was not found and was skipped']);
            emptyimages(z,2)=0;
        end
    end


    framestart=find(emptyimages(:,2)==1,1,'first');
    frameend=find(emptyimages(:,2)==1,1,'last');
    sizeimages=[size(Imagesshape{framestart,1},1) size(Imagesshape{framestart,1},2)];
    Znumberfr=frameend-framestart+1;


    %% Polarity stack sizing so that polarity and shape stacks have the same size...

    if find(emptyimages(:,1)==1,1,'first')<framestart
        disp('        Warning : polarity stack starts before shape stack. Additional slices will be deleted from polarity stack.');
    elseif find(emptyimages(:,1)==1,1,'first')>framestart
        for z=framestart:find(emptyimages(:,1)==1,1,'first')-1
            Imagespol{z,1}=zeros(sizeimages(1),sizeimages(2));
        end
        disp('        Warning : shape stack starts before polarity stack. Empty slices will be added to polarity stack.');
    end
    if find(emptyimages(:,1)==1,1,'last')>frameend
        disp('        Warning : polarity stack ends after shape stack. Additional slices will be deleted from polarity stack.');
    elseif find(emptyimages(:,1)==1,1,'last')<frameend
        for z=find(emptyimages(:,1)==1,1,'last')+1:frameend
            Imagespol{z,1}=zeros(sizeimages(1),sizeimages(2));
        end
        disp('        Warning : shape stack ends after polarity stack. Empty slices will be added to polarity stack.');
    end
    if isempty(find(emptyimages(:,1)==1,1,'last'))
        for z=framestart:frameend
            Imagespol{z,1}=zeros(sizeimages(1),sizeimages(2));
        end
        disp('        Warning : empty polarity stack. Empty slices will be added to polarity stack.');
    end

    disp('    formatting 3D polarity matrix...');
    Bsub=zeros(size(Imagespol{framestart,1},1),size(Imagespol{framestart,1},2),Znumberfr);	% new matrix for polarity, analog to Imagespol
    for zz=framestart:Znumberfr+framestart-1
        Bsub(:,:,(zz-framestart)+1)=Imagespol{zz,1};
    end

    max_intensity=max(max(max(Bsub)));    % Normalizing polarity intensity
    if max_intensity>0
        mult_int=100/max_intensity;
    else mult_int=100;
    end


    %% Identifying the different cells in the embryo 3D stack
    % The shape stack is labelled, and ovelaps between consequent slice allow to follow the cells through Z
    % In the end, all 3D cells have a different label

    Labeltemp{framestart,1}= Labelraw{framestart,1};
    maxnumcell=0;

    disp('    getting cells positions...');
    for z=framestart:frameend-1
        isempt=0;
        if isempty(Labelraw{z,1}) && miss_slides==0          % dealing with missing slices, so that the program doesn't see two cells
        else
            z0=z;
            while isempty(Labelraw{z0+1,1}) && z0<max(frames)-1
                z0=z0+1;
            end
            if isempty(Labelraw{z0+1,1}) && z0==max(frames)-1
            else
                if isempty(Labelraw{z,1}) && miss_slides==1
                    Labeltemp{z,1}=zeros(size(Imagesshape{framestart,1}));
                end

                corrtab=NaN(max(max(Labeltemp{z,1})),max(max(Labelraw{z0+1,1})));       % table of shared pixels between the labels of two consecutive slices.
                maxnumcell=max(maxnumcell,max(max(Labeltemp{z,1})));                               % number of different cells detected through the whole stack.
                for nbcell1=0:max(max(Labeltemp{z,1}))
                    for nbcell2=0:max(max(Labelraw{z0+1,1}))
                        corrtab(nbcell1+1,nbcell2+1)=length(intersect(find(Labeltemp{z,1}==nbcell1),find(Labelraw{z0+1,1}==nbcell2),'rows'));
                    end
                end
                corrtabackup=corrtab;

                colfond=Labelraw{z0+1,1}(1,1);      % To define the background on each slice : the color of the corner pixel. All pixels labeled the same are labelled 0.
                corrtab(1,:)=0;                                   % The corresponding pixels are erased from corrtab. Hence the disappearing cells are not a pb (erased as background twins).
                corrtab(:,colfond+1)=0;
                corrtabackup(:,colfond+1)=0;
                [lab1 lab2]=find(Labelraw{z0+1,1}==colfond);
                for lab1lab2=1:size(lab1,1)
                    Labeltemp{z0+1,1}(lab1(lab1lab2),lab2(lab1lab2))=0;
                end

                for nbcell=1:max(size(corrtab))-1       % Correlations on successive slices to follow cells.
                    if max(max(corrtab))>0
                        cor=0;
                        [cor1 cor2]=find(corrtab==max(max(corrtab)));   % the biggest value of corrtab is taken
                        [lab1 lab2]=find(Labelraw{z0+1,1}==cor2-1);     % The corresponding pixels of the 2nd slice...
                        for lab1lab2=1:size(lab1,1)
                            Labeltemp{z0+1,1}(lab1(lab1lab2),lab2(lab1lab2))=cor1-1;     % ...are set the same label as the corresponding pixels of the first slice.
                        end
                        corrtab(cor1,:)=0;                                % The corresponding pixels are erased from corrtab.
                        corrtab(:,cor2)=0;
                        corrtabackup(:,cor2)=0;

                    else
                        [cor1 cor2]=find(corrtabackup>0);       % The cells that don't find their twin (appearing cells)...
                        cor2=unique(cor2);
                        if ~isempty(cor2)
                            for cor=1:length(cor2)
                                corcor2=cor2(cor);
                                [lab1 lab2]=find(Labelraw{z0+1,1}==corcor2-1);
                                for lab1lab2=1:size(lab1,1)
                                    Labeltemp{z0+1,1}(lab1(lab1lab2),lab2(lab1lab2))=maxnumcell+cor;        % ...are given a new label.
                                end
                            end
                        end
                    end
                end
            end
        end
    end

    maxnumcell=maxnumcell+cor;
    disp(['        ' num2str(maxnumcell) ' cells found.']);
    disp(' ');
    clear Labelraw


    %% Isolating one cell (to later predict its division)

    for cellule=1:maxnumcell            % For every cell Division_prediction_program_11 will be launched...
        emptyimagestemp=emptyimages;
        if ismember(cellule,cellulechoix) || isempty(cellulechoix)  %...if the cell was selected in the Division_prediction_launcher
            Label=Labeltemp;            % label of just one cell, input data for the Division_prediction_program_11 program.
            surface = NaN(length(frames),1);
            volume=0;

            for z=framestart:frameend
                [lab2 lab3]=find(Label{z,1}~=0);
                [lab4 lab5]=find(Label{z,1}~=cellule);
                [lab6 lab7]=find(Label{z,1}==cellule);
                lab=intersect([lab2 lab3],[lab4 lab5],'rows');
                for lab1lab2=1:size(lab,1)
                    Label{z,1}(lab(lab1lab2,1),lab(lab1lab2,2))=0;      % The other cells are labelled 0.
                end
                for lab1lab2=1:size(lab6,1)
                    Label{z,1}(lab6(lab1lab2),lab7(lab1lab2))=1;    % This cell is labelled 1.
                end

                if isempty(find(Label{z,1}~=0,1))       % Slices where this cell doesn't appear are cleared.
                    emptyimagestemp(z,2)=0;
                else
                     Stat(z)=regionprops(Label{z,1},'Centroid','Orientation','Area','MajorAxisLength','MinorAxisLength'); %#ok<AGROW>
                end
            end

            disp(['running Division_prediction_program_11 on cell nb ' num2str(cellule) '...']);
            Division_prediction_program_11                  % Running the division prediction model on the selected cell

        end
    end
else
    
    disp(['running Division_prediction_program_11 on saved cell ' num2str(isave) '...']);
    Division_prediction_program_11
    
end


